/* (C) Copyright International Business Machines Corporation 23 January */
/* 1990.  All Rights Reserved. */
/*  */
/* See the file USERAGREEMENT distributed with this software for full */
/* terms and conditions of use. */
#ifndef lint
static char sccsinfo[] = "@(#)main.c	1.9 2/8/92";
#endif

/*
 1.  COPYRIGHT
 
     Program Name: Hermes
 
     (C) Copyright International Business Machines Corporation 23 January 1990.
     All Rights Reserved.
 
 
 2.  RESEARCH SOFTWARE DISCLAIMER
 
     As experimental, research software, this program is provided free of
     charge on an "as is" basis without warranty of any kind, either expressed
     or implied, including but not limited to implied warranties of
     merchantability and fitness for a particular purpose.  IBM does not
     warrant that the functions contained in this program will meet the user's
     requirements or that the operation of this program will be uninterrupted
     or error-free.  Acceptance and use of this program constitutes the user's
     understanding that he will have no recourse to IBM for any actual or
     consequential damages, including, but not limited to, lost profits or
     savings, arising out of the use or inability to use this program.  Even if
     the user informs IBM of the possibility of such damages, IBM expects the
     user of this program to accept the risk of any harm arising out of the use
     of this program, or the user shall not attempt to use this program for any
     purpose.
 
 
 3.  USER AGREEMENT
 
     BY ACCEPTANCE AND USE OF THIS EXPERIMENTAL PROGRAM THE USER AGREES TO THE
     FOLLOWING:
 
     a.  This program is provided for the user's personal, non-commercial,
         experimental use and the user is granted permission to copy this
         program to the extent reasonably required for such use.
 
     b.  All title, ownership and rights to this program and any copies remain
         with IBM, irrespective of the ownership of the media on which the
         program resides.
 
     c.  The user is permitted to create derivative works to this program.
         However, all copies of the program and its derivative works must
         contain the IBM copyright notice, the EXPERIMENTAL SOFTWARE DISCLAIMER
         and this USER AGREEMENT.
 
     d.  By furnishing this program to the user, IBM does NOT grant either
         directly or by implication, estoppel, or otherwise any license under
         any patents, patent applications, trademarks, copyrights or other
         rights belonging to IBM or to any third party, except as expressly
         provided herein.
 
     e.  The user understands and agrees that this program and any derivative
         works are to be used solely for experimental uses and are not to be
         sold, distributed to a commercial organization, or be commercially
         exploited in any manner.
 
     f.  IBM requests that the user supply to IBM a copy of any changes,
         enhancements, or derivative works which the user may create.  The user
         grants IBM and its subsidiaries an irrevocable, nonexclusive,
         worldwide and royalty-free license to use, execute, reproduce,
         display, perform, prepare derivative works based upon, and distribute,
         (INTERNALLY AND EXTERNALLY) copies of any and all such materials and
         derivative works thereof, and to sublicense others to do any, some, or
         all of the foregoing, (including supporting documentation).
 
         Copies of these modifications should be sent to:

                        SOFTWARE@YKTVMV.BITNET
			Hermes@IBM.Com
*/

#include <stdio.h>
#include <fcntl.h>

#include "release.h"

void
main(argc, argv, envp)
int argc;
char *argv[], *envp[];
{
    int imain();
    int exitcode;
    void save_stdio_flags(), restore_stdio_flags();
#ifdef sun
#ifdef DLOAD
    void fix_sun_dl();

    fix_sun_dl();
#endif DLOAD
#endif sun

    save_stdio_flags();
    exitcode = imain(argc, argv, envp);
    restore_stdio_flags();
    exit(exitcode);
}

static int stdin_flags, stdout_flags, stderr_flags;

void
save_stdio_flags()
{
  stdin_flags = fcntl(fileno(stdin), F_GETFL, 0);
  stdout_flags = fcntl(fileno(stdout), F_GETFL, 0);
  stderr_flags = fcntl(fileno(stderr), F_GETFL, 0);
}

void
restore_stdio_flags()
{
  (void) fcntl(fileno(stdin), F_SETFL, stdin_flags);
  (void) fcntl(fileno(stdout), F_SETFL, stdout_flags);
  (void) fcntl(fileno(stderr), F_SETFL, stderr_flags);
}


void
print_release()
{
  fprintf(stderr, "%s\n", hermes_release);
}

#ifdef sun
#ifdef DLOAD
int zero_fd = -1;

void
fix_sun_dl()
{
  /* /dev/zero is assumed open on fd 4 during the load operations, */
  /* but it gets closed after the initial linking at program */
  /* startup */
  int nullfd = open("/dev/null", O_RDONLY);
  zero_fd = open("/dev/zero", O_RDONLY);
  close(nullfd);
}

void refix_sun_dl()
{
  /* in case it ever gets closed again during a call to dlopen() */
  int fd = open("/dev/zero", O_RDONLY);
  if (fd != zero_fd) {
    dup2(fd, zero_fd);
    close(fd);
  }
}
#endif DLOAD
#endif sun
      
